# hfv_sc

## README

### Description

The code hfv_sc is an implementation of a structure-preserving Hybrid Finite Volume schemes for drift-diffusion systems.

The initial goal of this project is to introduce a scheme for models of semiconductor devices immersed in exterior magnetic fields.
Such phenomena is modelised by anistropic drift-diffusion equations, and the calssical Two Point Flux Approximation finite volume scheme cannot handle the anisotropy... <br>
The use of an Hybrid Finite Volume (HFV) method is hence a solution in order to approximate in a relevant way such anisotropic problem.
The nonlinear discretisation used ensures that the Boltzmann entropy structure of the continuous problem is conserved at the discrete level, and therefore ensures (among others features) that the computed densities are positive.

This code was used to get some numerical results presented in an [article](https://hal.science/hal-03715313v2) about structure-preserving schemes for semiconductor modles, as well as for the comparative work of a [proceeding](https://hal.science/hal-04037264) at the FVCA X conference.<br>

Another feature of intereset is the use of  locally refined (non conforming) meshes in order to improve the accuracy at a fixed computational cost.

#### Installation
 
The following softwares/libraries are required for compilation:

* C++
* CMake
* Eigen
* Boost 

To compile the code, you should create a build directory.


mkdir build                 <br>
cd build                    <br>
cmake ..                    <br>
make                        

The compilation will create a hfv directory, in which you can find and execute "hfv_advdiff_evol".
In order to get some data about visualisation, you should create an "output" directory in the build directory.

mkdir output       <br>
./bin/hfv_sc      <br>


### Getting started


The data of the problem (initial condition, doping profile, boundary values, physical data) can be specified in the ExactSolution constructor (file data.h).
Some specific test case already available in this file, and are commented.<br>
The statistics (nonlinearity in the diffusion) and the recombination-generation (reaction) terms can be specified in the beginning of the file "hfvSC.h" (some classical terms are commented).

When executing hfv_sc, you will be asked to choose a mesh, a final time and a time step.
Then, you have to choose if you want to visualise the profiles or not. <br>
The code will compute the apprixmate solution, and generate some files:
* "temps_long_impli.cvs", containing information about all the times of the computation; 
* "tps_impli", contaning the same kind of information as the previous file, but with a limited number of times (in order to print the information into graphs via pgfplots);
* visualisations data in the "output" folder.

The visualisation files (.vtu format) can be read directcly using Paraview. 

For the geometry of the doping profile used (PN junctions for diodes model), one can use the locally refined meshes of the family  "PN_" (meshes generated by J. Droniou).


### Authors 

Author: Julien Moatti (julien.moatti@tuwien.ac.at)


### License

GNU General Public License v3.0

### Project status

This has been created for personnal use. <br>
This code is currently updated in order to compute IV-curves and investigate the use of locally refined meshes.